*! version 0.2  25mar2020 [EM]

program define overwgt4

// Create weights within over groups

syntax varname , over(varname) [ generate(name) replace * ]

// Over must be a variable with categories 1, 2, ..., k
// with all k categories filled.
//
// * = options for trimmed_weight

local w `varlist'

summarize `over', meanonly
local ngrp = r(max)

tempvar w2 new
quietly generate double `new' = .
forvalues g=1/`ngrp' {
    // Create within-group weight
    quietly {
        generate double `w2' = `w' if (`over' == `g')
    }
    trimmed_weight `w2', replace `options'
    quietly {
        replace `new' = `w2' if (`over' == `g')
        drop `w2'
    }
}
if ("`replace'" != "") {
    // replace option chosen
    recast double `w'
    replace `w' = `new'
}
else {
    // generate option chosen
    rename `new' `generate'
}

end

exit

// EOF
